// Auto-generated. Do not edit!

// (in-package rc_tagdetect_client.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Tag = require('../msg/Tag.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

let DetectedTag = require('../msg/DetectedTag.js');
let rc_common_msgs = _finder('rc_common_msgs');

//-----------------------------------------------------------

class DetectTagsRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.tags = null;
      this.pose_frame = null;
      this.robot_pose = null;
    }
    else {
      if (initObj.hasOwnProperty('tags')) {
        this.tags = initObj.tags
      }
      else {
        this.tags = [];
      }
      if (initObj.hasOwnProperty('pose_frame')) {
        this.pose_frame = initObj.pose_frame
      }
      else {
        this.pose_frame = '';
      }
      if (initObj.hasOwnProperty('robot_pose')) {
        this.robot_pose = initObj.robot_pose
      }
      else {
        this.robot_pose = new geometry_msgs.msg.Pose();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type DetectTagsRequest
    // Serialize message field [tags]
    // Serialize the length for message field [tags]
    bufferOffset = _serializer.uint32(obj.tags.length, buffer, bufferOffset);
    obj.tags.forEach((val) => {
      bufferOffset = Tag.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [pose_frame]
    bufferOffset = _serializer.string(obj.pose_frame, buffer, bufferOffset);
    // Serialize message field [robot_pose]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.robot_pose, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type DetectTagsRequest
    let len;
    let data = new DetectTagsRequest(null);
    // Deserialize message field [tags]
    // Deserialize array length for message field [tags]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.tags = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.tags[i] = Tag.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [pose_frame]
    data.pose_frame = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [robot_pose]
    data.robot_pose = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.tags.forEach((val) => {
      length += Tag.getMessageSize(val);
    });
    length += _getByteLength(object.pose_frame);
    return length + 64;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_tagdetect_client/DetectTagsRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '5cc2624ec258258a00957ce25b4730c5';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Description: Triggers a detection for the given tags
    
    # Tags to detect. For pose estimation by homography, the sizes of the tags
    # must be set.
    Tag[] tags
    
    # Optional. Pose frame for output poses (valid values are 'camera' and 'external', defaults to 'camera')
    string pose_frame
    
    # Required only if reference frame = external and sensor is robot-mounted
    geometry_msgs/Pose robot_pose
    
    
    ================================================================================
    MSG: rc_tagdetect_client/Tag
    # Tag definition
    
    # ID of the tag.
    # For april tags, it is <family>_<tag_id>.
    # Available april tag families: 16h5, 25h7, 25h9, 36h10, 36h11.
    # Example: april tag family 25h7, tag id 5: 25h7_5.
    # For QR codes, it the the data contained in the QR code.
    string id
    
    # Side length of the (quadratic) tag.
    float64 size
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new DetectTagsRequest(null);
    if (msg.tags !== undefined) {
      resolved.tags = new Array(msg.tags.length);
      for (let i = 0; i < resolved.tags.length; ++i) {
        resolved.tags[i] = Tag.Resolve(msg.tags[i]);
      }
    }
    else {
      resolved.tags = []
    }

    if (msg.pose_frame !== undefined) {
      resolved.pose_frame = msg.pose_frame;
    }
    else {
      resolved.pose_frame = ''
    }

    if (msg.robot_pose !== undefined) {
      resolved.robot_pose = geometry_msgs.msg.Pose.Resolve(msg.robot_pose)
    }
    else {
      resolved.robot_pose = new geometry_msgs.msg.Pose()
    }

    return resolved;
    }
};

class DetectTagsResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.tags = null;
      this.timestamp = null;
      this.return_code = null;
    }
    else {
      if (initObj.hasOwnProperty('tags')) {
        this.tags = initObj.tags
      }
      else {
        this.tags = [];
      }
      if (initObj.hasOwnProperty('timestamp')) {
        this.timestamp = initObj.timestamp
      }
      else {
        this.timestamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('return_code')) {
        this.return_code = initObj.return_code
      }
      else {
        this.return_code = new rc_common_msgs.msg.ReturnCode();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type DetectTagsResponse
    // Serialize message field [tags]
    // Serialize the length for message field [tags]
    bufferOffset = _serializer.uint32(obj.tags.length, buffer, bufferOffset);
    obj.tags.forEach((val) => {
      bufferOffset = DetectedTag.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [timestamp]
    bufferOffset = _serializer.time(obj.timestamp, buffer, bufferOffset);
    // Serialize message field [return_code]
    bufferOffset = rc_common_msgs.msg.ReturnCode.serialize(obj.return_code, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type DetectTagsResponse
    let len;
    let data = new DetectTagsResponse(null);
    // Deserialize message field [tags]
    // Deserialize array length for message field [tags]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.tags = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.tags[i] = DetectedTag.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [timestamp]
    data.timestamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [return_code]
    data.return_code = rc_common_msgs.msg.ReturnCode.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.tags.forEach((val) => {
      length += DetectedTag.getMessageSize(val);
    });
    length += rc_common_msgs.msg.ReturnCode.getMessageSize(object.return_code);
    return length + 12;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_tagdetect_client/DetectTagsResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'ca0333eb8c1d7c135636b9a1bcd025d0';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    # List of detected tags.
    DetectedTag[] tags
    
    # Timestamp of the detection
    time timestamp
    
    # Return value
    rc_common_msgs/ReturnCode return_code
    
    
    ================================================================================
    MSG: rc_tagdetect_client/DetectedTag
    
    # Header
    std_msgs/Header header
    
    # Detected tag. The size will be set to the estimated tag size.
    Tag tag
    
    # 3D pose of the detected tag
    geometry_msgs/PoseStamped pose
    
    # Instance ID of the tag
    string instance_id
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: rc_tagdetect_client/Tag
    # Tag definition
    
    # ID of the tag.
    # For april tags, it is <family>_<tag_id>.
    # Available april tag families: 16h5, 25h7, 25h9, 36h10, 36h11.
    # Example: april tag family 25h7, tag id 5: 25h7_5.
    # For QR codes, it the the data contained in the QR code.
    string id
    
    # Side length of the (quadratic) tag.
    float64 size
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: rc_common_msgs/ReturnCode
    # This message shall be used in the response of services as a field called return_code.
    # Confer to ReturnCodeConsts message for commonly used return code definitions.
    
    # return codes
    # >=0 - success
    # < 0 - failure
    
    # return code
    int16 value
    
    # return message
    string message
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new DetectTagsResponse(null);
    if (msg.tags !== undefined) {
      resolved.tags = new Array(msg.tags.length);
      for (let i = 0; i < resolved.tags.length; ++i) {
        resolved.tags[i] = DetectedTag.Resolve(msg.tags[i]);
      }
    }
    else {
      resolved.tags = []
    }

    if (msg.timestamp !== undefined) {
      resolved.timestamp = msg.timestamp;
    }
    else {
      resolved.timestamp = {secs: 0, nsecs: 0}
    }

    if (msg.return_code !== undefined) {
      resolved.return_code = rc_common_msgs.msg.ReturnCode.Resolve(msg.return_code)
    }
    else {
      resolved.return_code = new rc_common_msgs.msg.ReturnCode()
    }

    return resolved;
    }
};

module.exports = {
  Request: DetectTagsRequest,
  Response: DetectTagsResponse,
  md5sum() { return 'f39b85684808eb87a22cfafcf5c30833'; },
  datatype() { return 'rc_tagdetect_client/DetectTags'; }
};
